/**********************************************************************************************************************

    AUFGABENBLATT 4 für normale Übungsgruppen - Allgemeine Informationen

    Das Projekt Aufgabenblatt4 besteht aus fünf Aufgaben in den Klassen Aufgabe1 bis Aufgabe5, die Sie erweitern und in
    den Übungen vom 4.5. bis 8.5. präsentieren müssen, falls Sie in einer normalen Übungsgruppe sind. Wenn Sie in einer
    Übungsgruppe für Fortgeschrittene sind (bzw. an PP teilnehmen), müssen Sie stattdessen AufgabenblattF1 lösen.

    Achten Sie bei der Implementierung von Aufgabe1 bis Aufgabe5 auf folgende Punkte:

    - Ändern Sie nur die Klassen Aufgabe1 bis Aufgabe5, lassen Sie alle anderen Klassen des Projekts unverändert.
    - Ihr Programm sollte den dazugehörenden Test (z.B. enthält Aufgabe1Test den Test zu Aufgabe1) bestehen.
    - Sie dürfen den Test zu einer Aufgabe nicht (!) verändern, da Sie sonst beim Übersetzen falsche Meldungen bekommen.
    - Bei jeder Aufgabe finden Sie Zusatzfragen. Diese Zusatzfragen beziehen sich thematisch auf das erstellte Programm.
      Sie müssen diese Zusatzfragen in der Übung beantworten können. Die Beantwortung von Zusatzfragen, die mit
      [optional] gekennzeichnet sind, ist (obwohl empfohlen) freiwillig und wird in der Übung nicht überprüft.
    - Verwenden Sie zur Ausgabe immer System.out.println().
    - Verwenden Sie keine speziellen Aufrufe aus der Java-API, die die Aufgaben vereinfachen würden.

    Abgabe:  Die Abgabe muss bis Sonntag, den 3.5. um 13:59 erfolgen. Alle Änderungen am Projekt in der
    Übungsumgebung, die bis zu diesem Zeitpunkt von Ihnen vorgenommen wurden, werden als Abgabe betrachtet.

***********************************************************************************************************************/

/*
    Aufgabe1) Mehrfache Rekursion versus einfache Iteration

    Implementieren Sie in Aufgabe1 je eine iterative (iter) und eine rekursive (rec) statische Methode, die für eine
    ganze nicht-negative Zahl n die Zahl L(n) berechnet. L(n) ist definiert durch:

        L(0) = 1
        L(1) = 1
        L(n) = L(n - 1) + L(n - 2) + 1  wenn  n > 1

    Rufen Sie in main die Methoden iter und rec mit allen Zahlen von 0 bis 30 auf und geben Sie die Ergebnisse aus.

    Zusatzfragen:
    1. Welche Vor- und Nachteile hat iter im Vergleich zu rec?
    2. Ist int als Ergebnistyp zur Lösung dieser Aufgabe geeignet? Warum? Welche Alternative(n) gibt es?
    3. Warum ist double kein geeigneter Ergebnistyp für diese Aufgabe?
    4. [optional] Vermutlich enthält Ihre erste Implementierung von rec zwei rekursive Aufrufe. Versuchen Sie rec so
       abzuändern, dass nur ein rekursiver Aufruf nötig ist. Wie wirkt sich die Änderung auf die Vor- und Nachteile aus?
    5. [optional] In der Implementierung von iter sind keine Arrays nötig. Man könnte sie aber (auf unterschiedliche
       Arten) verwenden. Welche Vor- und Nachteile ergeben sich in dieser Aufgabe aus der Verwendung von Arrays?
*/
public class Aufgabe1 {

    // invokes iter as well as rec with all integers from 0 to 30 and prints the results
    // (without empty lines or other output)
    public static void main(String[] args) {
        // TODO: Implementation is your task
    }
}
