import org.junit.Rule;
import org.junit.Test;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.lang.reflect.Method;

import org.junit.contrib.java.lang.system.StandardOutputStreamLog;
import org.junit.rules.Timeout;

import static org.junit.Assert.assertEquals;

public class Aufgabe4Test {

    @Rule
    public final StandardOutputStreamLog log = new StandardOutputStreamLog();

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    @Test
    public void testOutput() throws Exception {
        System.out.println();
        System.out.println("Test-Output zu Aufgabe4:");

        String[] testValues = new String[]{
                "",
                "Test-Output zu Aufgabe4:",
                "Ergebnisse für f:",
                "0",
                "0",
                "0",
                "0",
                "0",
                "0",
                "0",
                "1",
                "2",
                "3",
                "4",
                "5",
                "6",
                "7",
                "0",
                "0",
                "0",
                "0",
                "0",
                "0",
                "0",
                "Ergebnisse für g:",
                "0",
                "0",
                "0",
                "0",
                "0",
                "0",
                "0",
                "0",
                "0",
                "0",
                "Ergebnisse für h:",
                "1",
                "1",
                "1",
                "1",
                "1",
                "1",
                "1",
                "2",
                "2",
                "2",
                "2",
                "1",
                "1",
                "1",
                "1",
                "1",
                "1",
                "1",
                "Ergebnisse für p:",
                "7",
                "5",
                "3",
                "1",
                "0",
                "2",
                "4",
                "6",
                "Ergebnisse für q:",
                "0",
                "1",
                "0",
                "1",
                "0",
                "1",
                "0",
                "1",
                "0",
                "1",
                "0",
                "1",
                "0",
                "1"
        };
        StringBuilder testString = new StringBuilder();
        for(String i: testValues) {
            testString.append(i).append(System.lineSeparator());
        }
        Aufgabe4.main(new String[]{});
        assertEquals(testString.toString(), log.getLog());
    }

}